require "defines"

function InfiniteWalk()
	-- config
	local walking_direction = defines.direction.west
	local auto_destroy_area_radius = 2; -- square around the player with given radius. Square size = (2*radius)^2
	local auto_destroy_per_ticks = 10; -- check after this amount of ticks have elapsed	
	local game_speed = 2;
	local player = nil

	-- variables
	for key, known_player in pairs( game.players ) do
		if known_player.connected == true then
			player = known_player;
		end		
	end

	local offset = auto_destroy_area_radius;
	if player ~= nil then
		local surface = player.surface;
		local position = player.position;
		
		game.speed = game_speed;

		-- automated walking
		player.walking_state = {walking = true, direction = walking_direction}

		-- only executed every {auto_destroy_per_ticks} ticks
		if game.tick % auto_destroy_per_ticks == 0 then
			-- could be optimized when taking walking direction into account (parts of the area don't need to be checked)
			local entities = surface.find_entities{{position.x-offset, position.y-offset}, {position.x+offset, position.y+offset}};

			for key, entity in pairs( entities ) do
				if entity.type ~= "player" then -- don't kill players, including self ;)
					--player.print(entity.name)
					entity.destroy();
				end
			end
		end
	end
end

-- register function to run every tick
script.on_event(defines.events.on_tick, InfiniteWalk)